<script setup lang="ts">
import type { Product } from '@/types/Stock'
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'

const page = ref(1)
const itemsPerPage = ref<any>(8)
const dialog = ref(false)
const search = ref<string>('')
const products = ref<Product[]>([])
const dialogDelete = ref(false)
const updateDialog = ref(false)
let editedIndex = -1
const DetailDialog = ref(false)
const loading = ref(false)
const refForm = ref<VForm | null>(null)
const initialProduct: Product = {
  id: -1,
  name: '',
  price: 0,
  quantity: 0,
  value: 0,
  stock: false
}
let lastId = 11
const pageCount = computed(() => {
  return Math.ceil(products.value.length / itemsPerPage.value)
})
const editedProduct = ref<Product>(JSON.parse(JSON.stringify(initialProduct)))
const filteredProducts = computed(() => {
  const searchLower = search.value.toLowerCase()
  return formattedProducts.value.filter((product) =>
    product.name.toLowerCase().includes(searchLower)
  )
})
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Price',
    key: 'price',
    value: (item: Product) => item.price.toFixed(2)
  },
  {
    title: 'Quantity',
    key: 'quantity',
    value: 'quantity'
  },
  {
    title: 'Value',
    key: 'value',
    value: (item: Product) => item.value.toFixed(2)
  },
  {
    title: 'Stock',
    key: 'stock',
    value: 'stock'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]
const OutofStockCount = computed(() => products.value.filter((product) => product.quantity == 0))
const formattedProducts = computed(() =>
  products.value.map((product) => ({
    ...product,
    value: product.price * product.quantity
  }))
)
const totalStoreValue = computed(() =>
  formattedProducts.value.reduce((total, product) => total + product.value, 0).toFixed(2)
)
const Addnewdialog = ref(false)
function initialize() {
  products.value = [
    {
      id: 1,
      name: 'Sugar',
      price: 46,
      quantity: 10,
      value: 0,
      stock: true
    },
    {
      id: 2,
      name: 'Honey',
      price: 38,
      quantity: 6,
      value: 0,
      stock: true
    },
    {
      id: 3,
      name: 'Green tea powder',
      price: 73,
      quantity: 8,
      value: 0,
      stock: true
    },
    {
      id: 4,
      name: 'Dough',
      price: 33,
      quantity: 12,
      value: 0,
      stock: true
    },
    {
      id: 5,
      name: 'Coffee Beans',
      price: 189,
      quantity: 6,
      value: 0,
      stock: true
    },
    {
      id: 6,
      name: 'Whipped Cream',
      price: 125,
      quantity: 4,
      value: 0,
      stock: true
    },
    {
      id: 7,
      name: 'Syrup',
      price: 190,
      quantity: 8,
      value: 0,
      stock: true
    },
    {
      id: 8,
      name: 'cocoa powder',
      price: 140,
      quantity: 0,
      value: 0,
      stock: true
    },
    {
      id: 9,
      name: 'Condensed Milk',
      price: 27,
      quantity: 10,
      value: 0,
      stock: true
    },
    {
      id: 10,
      name: 'Milk',
      price: 37,
      quantity: 0,
      value: 0,
      stock: true
    }
  ]
}
onMounted(() => {
  initialize()
})
function deleteItem(item: Product) {
  editedIndex = products.value.findIndex((p) => p.id === item.id)
  dialogDelete.value = true
}
function deleteItemConfirm() {
  products.value.splice(editedIndex, 1)
  closeDelete()
  editedIndex = -1
}
function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedProduct.value = Object.assign({}, initialProduct)
  })
}
function editItem(item: Product) {
  editedIndex = products.value.findIndex((p) => p.id === item.id)
  editedProduct.value = Object.assign({}, item)
  Addnewdialog.value = true
}
function DetailProduct(item: Product) {
  editedIndex = products.value.findIndex((p) => p.id === item.id)
  editedProduct.value = Object.assign({}, item)
  DetailDialog.value = true
}
async function save() {
  const { valid } = await refForm.value!.validate()

  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(products.value[editedIndex], editedProduct.value)
  } else {
    editedProduct.value.id = lastId
    lastId++
    products.value.push(editedProduct.value)
  }
  closeDialog()
  editedIndex = -1
} function closeDetail() {
  DetailDialog.value = false
}

function closeDialog() {
  Addnewdialog.value = false
  nextTick(() => {
    editedProduct.value = Object.assign({}, initialProduct)
    editedIndex = -1
  })
}
function closeUpdate() {
  updateDialog.value = false
}
</script>

<template>
  <div>

    <br>
    <!-- inventory stat -->
    <div class="text-center">

      <h1 style="text-align:left" class="ml-5">INVENTORY STATUS</h1>
      <v-btn class="ma-2" style="background-color: darkorchid">
        <v-icon end icon="mdi-cart" size="25px" class="mr-2"></v-icon>
        <div style="text-align: left">
          Total Product <br />
          {{ products.length }}
        </div>
      </v-btn>
      <v-btn class="ma-2" style="background-color: limegreen">
        <v-icon end icon="mdi-currency-usd" size="30px" class="mr-2"></v-icon>
        <div style="text-align: left">
          Total Stock Value <br />
          {{ totalStoreValue }}
        </div>
      </v-btn>
      <v-btn class="ma-2" style="background-color: crimson">
        <v-icon icon="mdi-cart-off" size="30px" class="mr-2"></v-icon>
        <div style="text-align: left">
          Out Of Stock <br />
          {{ OutofStockCount.length }}
        </div>
      </v-btn>

    </div>

    <!-- table -->
    <div>
      <v-card-title class="d-flex align-center pe-2">
        <v-icon icon="mdi-package-variant"></v-icon> &nbsp; INVENTORY ITEM
        <v-spacer></v-spacer>
        <!-- ปุ่ม search -->
        <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line flat
          hide-details variant="solo-filled"></v-text-field>
      </v-card-title>

      <v-data-table v-model:page="page" :headers="(headers as any)" :items="filteredProducts"
        :items-per-page="itemsPerPage">
        <template v-slot:bottom>
          <div class="text-center pt-2">
            <v-pagination v-model="page" :length="pageCount"></v-pagination>
          </div>
        </template>
        <!-- Stock Status -->
        <template v-slot:[`item.stock`]="{ item }">
          <div class="text-left">
            <v-chip :color="item.quantity > 0 ? 'green' : 'red'" :text="item.quantity > 0 ? 'In stock' : 'Out of stock'"
              class="text-uppercase" label size="small"></v-chip>
          </div>
        </template>

        <!-- Stock Action -->
        <template v-slot:[`item.actions`]="{ item }">
          <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil</v-icon>
          <v-icon size="small" @click="deleteItem(item)" class="mr-2"> mdi-delete </v-icon>
          <v-icon size="small" @click="DetailProduct(item)">mdi-magnify</v-icon>
        </template>
      </v-data-table>
    </div>

    <!-- deleteDialog -->
    <v-dialog v-model="dialogDelete" max-width="500px">
      <v-card>
        <v-card-title class="font ma-4 pt-6" style="text-align: center;">you want to delete this info? 🗑️</v-card-title>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
            @click="closeDelete">Cancel</v-btn>
          <v-spacer></v-spacer>
          <v-btn color="success" variant="flat" style="width: 150px; height: 50px" class="mb-3"
            @click="deleteItemConfirm">OK</v-btn>
          <v-spacer></v-spacer>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- DetailProduct -->
    <v-dialog v-model="DetailDialog" max-width="600px" persistent>
      <v-card>
        <v-card-title class="font ma-4 pt-4" style="text-align: center;">Detail Product</v-card-title>
        <v-card-actions v-model="editedProduct">
          <v-card-text style="margin-left:30px; font-size: large;">
            <v-row>
              <v-img :src="`./imgStock/Stock/stock${editedProduct.id}.jpg`" height="550" cover></v-img>
            </v-row>
            <v-row>
              <v-col cols="4">ID:{{ editedProduct.id }} </v-col>
              <v-col cols="5">Name:{{ editedProduct.name }}</v-col>

              <v-col cols="'3'"></v-col>
            </v-row>
            <v-row>
              <v-col>Price:{{ editedProduct.price.toFixed(2) }}</v-col>
              <v-col>Quantity:{{ editedProduct.quantity }}</v-col>
              <v-col>value:{{ editedProduct.value.toFixed(2) }}</v-col>
            </v-row>
            <br>
            <v-row>
              <v-btn color="red" variant="flat" style="width: 150px; height: 50px" class="mb-3"
                @click="closeDetail()">Close</v-btn>
            </v-row>
          </v-card-text>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <!-- show out of stock -->
    <div class="text-right">
      <v-btn style="background-color: crimson; width: 150px; height: 45px" class="mr-4">
        Out of Stock
        <v-dialog v-model="dialog" activator="parent" width="auto" height="auto">
          <v-card>
            <v-card-title>OUT OF STOCK</v-card-title>
            <v-data-table v-model:page="page" :headers="(headers as any)" :items="OutofStockCount"
              :items-per-page="itemsPerPage">
              <template v-slot:bottom>
                <div class="text-center pt-2">
                  <v-pagination v-model="page"></v-pagination>
                </div>
              </template>
              <template v-slot:[`item.stock`]="{ item }">
                <div class="text-left">
                  <v-chip :color="item.quantity > 0 ? 'green' : 'red'"
                    :text="item.quantity > 0 ? 'In stock' : 'Out of stock'" class="text-uppercase" label
                    size="small"></v-chip>
                </div>
              </template>
              <template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil</v-icon>
                <v-icon size="small" @click="deleteItem(item)" class="mr-2"> mdi-delete </v-icon>
                <v-icon size="small" @click="DetailProduct(item)">mdi-alert-circle</v-icon>
              </template>
            </v-data-table>
            <div class="text-right">
              <v-btn @click="dialog = false" style="width: 150px; height: 50px" variant="flat" class="mr-4"
                color="red">Close</v-btn>
            </div>
            <br />
          </v-card>
        </v-dialog>
      </v-btn>

      <!-- EditProduct -->
      <v-btn style="background-color: steelblue; width: 150px; height: 45px" class="mr-4">
        Add Product
        <v-dialog v-model="Addnewdialog" activator="parent" width="auto" persistent>
          <v-sheet width="400" height="450" class="mx-auto">
            <v-card-title style="text-align: center">Product</v-card-title>
            <v-form fast-fail @submit.prevent ref="refForm" style="margin-left: 10px; margin-right: 10px">
              <v-text-field clearable v-model="editedProduct.name" label="Product Name" variant="outlined" class="mb-3"
                :readonly="loading" :rules="[(v) => !!v || 'Field is required']"></v-text-field>
              <v-text-field type="number" clearable v-model.number="editedProduct.price" label="Product Price"
                variant="outlined" :readonly="loading" :rules="[(v) => v >= 0]"></v-text-field>
              <v-text-field type="number" clearable v-model.number="editedProduct.quantity" label="Product Quantity"
                :readonly="loading" variant="outlined" :rules="[(v) => v >= 0]"></v-text-field>
              <v-file-input prepend-icon="mdi-camera" label="Product Image" variant="outlined" class="mb-3"
                :readonly="loading"></v-file-input>
              <v-btn style=" width: 150px; height: 50px" variant="flat" @click="closeDialog" class="ms-5"
                color="red">Cancel</v-btn>
              <v-btn style="width: 150px; height: 50px" variant="flat" @click="save" class="ms-10"
                color="success">Save</v-btn>
            </v-form>
          </v-sheet>
        </v-dialog>
      </v-btn>
      <!-- UPDATE STOCK -->
      <v-btn style="background-color: goldenrod; width: 150px; height: 45px" class="mr-4">
        Update Stock
        <v-dialog v-model="updateDialog" activator="parent" width="400" persistent>
          <v-card>
            <v-card-title style="text-align: center;">
              <span class="font">UPDATE STOCK</span>
            </v-card-title>
            <v-sheet class="overflow-auto">
              <v-table>
                <thead>
                  <tr>
                    <th class="text-center">Name</th>
                    <th class="text-left">Quantity</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in products" :key="item.name">
                    <td>{{ item.name }}</td>
                    <td>
                      <v-responsive max-width="100">
                        <v-text-field v-model="item.quantity"></v-text-field>
                      </v-responsive>
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-sheet>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="red" style="width: 150px; height: 50px" variant="flat" @click="closeUpdate()">
                Close
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-btn>
    </div>
    <br>
  </div>
</template>

<style scoped>
.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}

.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: Verdana, sans-serif;
}

div {
  font-family: 'Kanit';
}
</style>
